# -*- coding: utf-8 -*-
"""
Created on Mon Oct 11 02:17:51 2021

@author: chadi

Revision:
- GP (30/09/2023) :
    - beautify code
    - improve code readibility for activation samples
- GP (05/02/2024) : 
    - make choice with track number
    - reorganize files and folders
        - use symlinks to avoid redundancy on /cal
"""
from playsound import playsound
import soundfile as sf
from scipy.io.wavfile import write
import numpy as np


# Please set the track number according to your liking
track_number = 1

# 0: Clean_norm.wav
# 1: comfortably_norm.wav
# 2: HappyBirthday.wav
# 3: Sultans_norm.wav
# 4: Teardrop.wav
# 5: Una-Mattina.wav
# 6: wall_norm.wav

# List of tracks (as tuple (ordered and unchangeable))
tracks = (
"Clean_norm.wav", \
"comfortably_norm.wav", \
"HappyBirthday.wav", \
"Sultans_norm.wav", \
"Teardrop.wav", \
"Una-Mattina.wav", \
"wall_norm.wav", \
)



y, fs = sf.read(tracks[track_number]) 

Ts            = 1./fs
N             = len(y)
effet         = 1                     # Pour activer et désativer le Tremolo
activation    = [[1e-3, 1],[  5, 10 ]]# interval d'activation en seconde
fin_or        = 5.0                   # Fréquence du tremolo
m             = 0.9                   # indice de la modulation

# Convert activation time to sample number
activation_sample = np.array(activation)
activation_sample = np.floor(activation_sample/Ts).astype(int)

if (effet):
    Bin_in          = round(fin_or/fs*N)
    fin             = Bin_in*fs/N
    t               = np.arange(0,N*Ts,Ts)
    modulant_base   = np.cos(2*np.pi*fin*t)
    act             = np.ones(N)
    nbact           = len(activation)
    for i in range(0,nbact):
        # act contains 1 for samples that are not in the activation interval
        # and contains the modulating function for samples that are in the activation interval
        act[activation_sample[i][0]:activation_sample[i][1]] \
        = modulant_base[1:activation_sample[i][1]-activation_sample[i][0]+1]
    # Apply the modulation
    y = y*(m*act+1)
         



write('test.wav', fs, y)
playsound('test.wav')


